package cz.frantovo.nekurak.ejb;

import cz.frantovo.nekurak.dao.PodnikDAO;
import cz.frantovo.nekurak.dto.Podnik;
import cz.frantovo.nekurak.ejb.Geo.Souradnice;
import java.util.Collection;
import javax.annotation.Resource;
import javax.annotation.security.RolesAllowed;
import javax.ejb.EJB;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;

/**
 *
 * @author fiki
 */
@Stateless
public class PodnikEJB implements PodnikRemote {

    @EJB
    private PodnikDAO podnikDAO;
    @Resource
    private SessionContext ctx;

    public Collection<Podnik> getPodniky() {
	Collection<Podnik> vysledek = podnikDAO.getPodniky();
	return vysledek;
    }

    public Podnik getPodnik(int id) {
	return podnikDAO.getPodnik(id);
    }

    @RolesAllowed("opravneny")
    public void zalozPodnik(Podnik p) {
	p.setSpravce(ctx.getCallerPrincipal().getName());
	podnikDAO.zaloz(p);
    }

    @RolesAllowed("opravneny")
    public void upravPodnik(Podnik p) {
	podnikDAO.uloz(p);
    }

    public int dopocitejSouradnice() {
	/**
	 * TODO:    refaktorovat, změnit datové typy, souřadnice…
	 */
	Geo g = new Geo();
	int pocetAktualizovanych = 0;

	for (Podnik p : podnikDAO.getPodnikyBezSouradnic()) {
	    Souradnice s = g.getSouradnice(p.getUlice() + " " + p.getCisloPopisne() + ", " + p.getMesto());
	    if (s != null) {
		pocetAktualizovanych++;
		p.setSirka(s.getSirka());
		p.setDelka(s.getDelka());
		podnikDAO.uloz(p);
	    }
	}

	return pocetAktualizovanych;
    }
}
